
#    LUCI is an Universal Configuration Interface
#    Copyright (C) 1999-2001 Jrme SAUTRET <Jerome.Sautret@netcourrier.com>
#                                                                
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or   
#    (at your option) any later version.                              
#                                      
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details.                 
#                                               
#    You should have received a copy of the GNU General Public License
#    along with this program; see the file COPYING.  If not, write to 
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#    Boston, MA 02111-1307, USA.


import os, stat
from gtk import *
import gui_entries

def cb_node_select(root, container, config, file):
    config['desc_file_name']=file
    gui_entries.init_entries(container, config.copy())

def cb_node_unselect(root, container, config, file):
    try:
        container.children()[0].destroy()
    except IndexError:
        None
    #container.set_usize(0,0)


def create_tree(container, config, parent, dir):
    listdir=os.listdir(dir)
    for f in listdir:
        path='%s/%s' % (dir, f)
        # ignore compiled files (ending with a c)
        if f[-1:]!='c' or f[:-1] not in listdir:
            node=GtkTreeItem(f)
            parent.append(node)
            #node.connect("toggle", toggle)
            node.show()
            mode = os.stat(path)[stat.ST_MODE]
            if stat.S_ISDIR(mode):
                subtree=GtkTree()
                subtree.set_selection_mode(SELECTION_SINGLE)
                subtree.set_view_mode(TREE_VIEW_ITEM)
                node.set_subtree(subtree)
                subtree.set_selection_mode(SELECTION_SINGLE)
                create_tree(container, config, subtree, path)
            else:
                node.connect("select", cb_node_select, container, config, path)
                node.connect("deselect", cb_node_unselect, container, config, path)

            
    
def tree_win(container, config):
    "create the tree window. container is where to add entries window"
    win=GtkScrolledWindow()
    win.set_usize(150, 200)
    win.set_policy(POLICY_AUTOMATIC,POLICY_AUTOMATIC)
    tree=GtkTree()
    tree.set_selection_mode(SELECTION_SINGLE)

    create_tree(container, config, tree, config['desc_dir'])

    win.add_with_viewport(tree)
    tree.show()
    win.show()
    return win
